;--------------------------------------------------------------------------
;  crt0.s - Generic crt0.s for a Z80
;
;  Copyright (C) 2000, Michael Hope
;
;  This library is free software; you can redistribute it and/or modify it
;  under the terms of the GNU General Public License as published by the
;  Free Software Foundation; either version 2, or (at your option) any
;  later version.
;
;  This library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License 
;  along with this library; see the file COPYING. If not, write to the
;  Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston,
;   MA 02110-1301, USA.
;
;  As a special exception, if you link this library with other files,
;  some of which are compiled with SDCC, to produce an executable,
;  this library does not by itself cause the resulting executable to
;  be covered by the GNU General Public License. This exception does
;  not however invalidate any other reasons why the executable file
;   might be covered by the GNU General Public License.
;--------------------------------------------------------------------------

	J_JPTBL        == 0xffe0	; RAMւ̃ANZXp
	J_PUTCHAR      == 0xb01e	; P\
	J_GETCHAR      == 0xb021	; P
	J_DATA_READ    == 0xb024	; f[^t@CPǂݏo
	J_DATA_READSET == 0xb027	; f[^t@Cǂݏopݒ
	J_SECWR_SET    == 0xb02a	; obt@̓efBXNɏ
	J_SECWR_BYTE   == 0xb02d	; obt@ɂPoCg
	J_SECRD_SET    == 0xb030	; obt@ɃfBXNǂݏo
	J_SECRD_BYTE   == 0xb033	; obt@PoCgǂݏo
	J_UNGETCIN     == 0xb036	; ̓obt@ɂPoCg߂
	J_GETRREG      == 0xb039	; RWX^̒lԂ


	.module crt0
	.globl	_main

	.area	_CODE

	ld	a,#0xee
	out	(#0xf0),a
	out	(#0xf1),a
	ld	a,#0xaa
	out	(#0xf2),a

	ld	hl,#0xc000
	ld	de,#0x8000
	ld	bc,#0x4000
	ldir

	call	gsinit
	call	_main
1$:	jr	1$

	;; Ordering of segments for the linker.
	.area	_HOME
	.area	_CODE
	.area	_INITIALIZER
	.area   _GSINIT
	.area   _GSFINAL

	.area	_INITIALIZED
	.area	_DATA
	.area   _HEAP

	.area   _GSINIT
gsinit::
	ld	hl, #s__DATA
	ld	bc, #l__DATA
_clear_loop:
	ld	(hl), #0
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,_clear_loop

	ld	bc, #l__INITIALIZER
	ld	a, b
	or	a, c
	jr	Z, gsinit_next
	ld	de, #s__INITIALIZED
	ld	hl, #s__INITIALIZER
	ldir
gsinit_next:

	.area   _GSFINAL
	ret

