
#include <stdio.h>
#include <stdarg.h>

void warn(const char *, ...);
void exit(int);

void exit(int x)
{
	printf("\n\nProgram End\n");
	for (;;) {
	}
}

void perror(const char *ptr)
{
	printf("Error : %s\n",ptr);
}

void err(int eval, const char *fmt, ...)
{
	warn(fmt);
	exit(eval);
}

void errx(int eval, const char *fmt, ...)
{
	warn(fmt);
	exit(eval);
}

void warn(const char *fmt, ...)
{
	va_list v;
	char buf[80];

	if(fmt == NULL)
		perror(NULL);
	else {
		va_start(v, fmt);
		vsprintf(buf, fmt, v);
		va_end(v);
		perror(buf);
	}
}

