
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "file60.h"

FILE filesave;	/* Z[uf[^p\́iP̂݁j */

int calc_sec(void);
int new_sec(void);

#define	STARTTRK	35			/* Z[uf[^̐擪gbNԍ */

FILE *fopen(const char *fname, const char *str)
{

	if ( (fname[1] != 0) || (fname[0] < '1') || (fname[0] > '5') ) {
		return NULL;	/* ERROR */
	}
	filesave.st_track	= STARTTRK + (fname[0] - '1');
	filesave.st_sector	= 0x01;

	if        (strncmp(str,"rb",3) == 0) {
		filesave.mode = FILE_MODE_RB;
	} else if (strncmp(str,"wb",3) == 0) {
		filesave.mode = FILE_MODE_WB;
	} else {
		return NULL;	/* ERROR */
	}

	filesave.err	= FILE_ERR_NOERR;
	filesave.ptr	= 0;

	calc_sec();
	if (secrd_set(filesave.track, filesave.sector) != FILE_ERR_NOERR) {
		return NULL;	/* ERROR */
	}
	filesave.buftrack	= filesave.track;
	filesave.bufsector	= filesave.sector;

	return &filesave;
}

int fclose(FILE *fp)
{

	if (fp == NULL) {
		return EOF;		/* pointer ERROR */
	}

	if (filesave.err != FILE_ERR_NOERR) {
		return EOF;		/* file ERROR */
	}

	if (secwr_set(filesave.buftrack, filesave.bufsector) != FILE_ERR_NOERR) {
		return EOF;		/* pointer ERROR */
	}

	return 0;
}

size_t fwrite(const void *buf, size_t size, size_t nmemb, FILE *fp)
{
	size_t	i,j;
	unsigned char	*buftmp;

	if (fp == NULL) {
		return 0;		/* pointer ERROR */
	}

	if (filesave.mode != FILE_MODE_WB) {
		return 0;
	}
	if (filesave.err != FILE_ERR_NOERR) {
		return 0;
	}

	buftmp = (unsigned char *)buf;

	for (j = 0; j < nmemb; j ++) {
		for (i = 0; i < size; i ++) {
			if (new_sec() != 0) {
				return j;
			}
			secwr_byte(filesave.ptr, *buftmp);
			buftmp ++;
			filesave.ptr ++;
		}
	}

	return j;
}

size_t fread(void *buf, size_t size, size_t nmemb, FILE *fp)
{
	size_t	i,j;
	unsigned char	*buftmp;

	if (fp == NULL) {
		return 0;		/* pointer ERROR */
	}

	if (filesave.mode != FILE_MODE_RB) {
		return 0;
	}
	if (filesave.err != FILE_ERR_NOERR) {
		return 0;
	}

	buftmp = (unsigned char *)buf;

	for (j = 0; j < nmemb; j ++) {
		for (i = 0; i < size; i ++) {
			if (new_sec() != 0) {
				return j;
			}
			*buftmp = secrd_byte(filesave.ptr);
			buftmp ++;
			filesave.ptr ++;
		}
	}

	return j;
}

int calc_sec()
{
	unsigned char	nowsector, nowtrack;

	nowsector = ( (filesave.ptr & 0x0f00) >>  8) + filesave.st_sector;
	nowtrack  = ( (filesave.ptr & 0xf000) >> 12) + filesave.st_track;

	if (nowsector > 16) {
		nowsector -= 16;
		nowtrack ++;
	}

	filesave.track  = nowtrack;
	filesave.sector = nowsector;

	if (nowtrack == filesave.buftrack && nowsector == filesave.bufsector) {
		return 0;
	}

	return EOF;
}

int new_sec()
{

	if (calc_sec() != 0) {
		if (filesave.mode == FILE_MODE_WB) {
			if (secwr_set(filesave.buftrack, filesave.bufsector) != FILE_ERR_NOERR) {
				filesave.err = FILE_ERR_ERR;
				return EOF;
			}
		}
		if (secrd_set(filesave.track, filesave.sector) != FILE_ERR_NOERR) {
			filesave.err = FILE_ERR_ERR;
			return EOF;
		}
		filesave.buftrack  = filesave.track;
		filesave.bufsector = filesave.sector;
	}

	return 0;

}
