;
; BIOS[`
;

	relaxed on

Disk_Routine	equ	$bd00		; fBXN[`i[AhX
Disk_Load	equ	Disk_Routine+3	; fBXN[h
Disk_Save	equ	Disk_Routine+6	; fBXN[h

DISKBUF		equ	$bc00		; fBXNpǂݏoobt@
DATATR		equ	13		; Of[^̊JngbNԍ

STDINBUFLEN	equ	76		; W̓obt@TCY
STDOUTLEN	equ	78		; Ps̕

;
; 荞݃xN^
;
	org	$b000

INT_TABLE:
	dw	INTDT0		; 0x00
	dw	INTKEYIN	; 0x02iKEYINPUTj
	dw	INTDT0		; 0x04iRS-232Cj
	dw	INTTIMER	; 0x06iTIMERj
	dw	INTDT1		; 0x08iCMT READj
	dw	INTDT0		; 0x0A
	dw	INTDT0		; 0x0C
	dw	INTDT1		; 0x0EiL[́j
	dw	INTDT1		; 0x10iL[́j
	dw	INTDT0		; 0x12iCMT ERRORj
	dw	INTKEYIN2	; 0x14iL[́j
	dw	INTGAMEKEY	; 0x16iQ[L[́j

;
; Wve[u
;

	jp	INIT_BIOS	; 0xb018
	jp	JPMAIN		; 0xb01b
	jp	PUTCHAR		; 0xb01e
	jp	GETCHAR		; 0xb021
	jp	DATA_READ	; 0xb024
	jp	DATA_READSET	; 0xb027
	jp	SECWR_SET	; 0xb02a
	jp	SECWR_BYTE	; 0xb02d
	jp	SECRD_SET	; 0xb030
	jp	SECRD_BYTE	; 0xb033
	jp	UNGETCIN	; 0xb036
	jp	GETRREG		; 0xb039

;
; TuCPUւPoCgf[^𑗐M
;
; Areg=Mf[^
;
SETSUBCPU:
	push	af
	ld	a,$08
	out	($93),a
.wait:
	in	a,($92)
	and	$80
	jr	z,.wait
	ld	a,$09
	out	($93),a
	pop	af
	out	($90),a
	ret

;
; TuCPUPoCgf[^M
;
; RETFAreg=Mf[^
;
GETSUBCPU:
	ld	a,$0c
	out	($93),a
.wait:
	in	a,($92)
	and	$20
	jr	z,.wait
	ld	a,$0d
	out	($93),a
	in	a,($90)
	ret

;
; 荞ݏI[if[^PoCgM{Ȃj
;
INTDT1:
INTGAMEKEY:			; Q[L[荞݁igpj
	push	af
	call	GETSUBCPU
	pop	af

; 荞ݏI[iȂj
;
INTDT0:
	ei
	ret

;
; L[͊荞
;
; ʏL[iASCIIR[hj
;
INTKEYIN:
	push	af

	call	GETSUBCPU
	cp	$0d		; CR
	jr	nz,.lp1
	ld	a,$0a		; LF (0x0d -> 0x0a)
.lp1:
	push	af
	cp	$21		; pŏ
	jr	c,.end
	cp	$7f		; pŌ{P
	jr	nc,.n1
	ld	a,$00		; p
	jr	.n2
.n1:
	cp	$86		; ȍŏ
	jr	c,.end
	cp	$fe		; ȍŌ{P
	jr	nc,.end

	ld	a,$ff		; 
.n2:
	ld	(KANAFLAG),a
.end
	pop	af
	ld	(KEYDATA),a
	xor	a
	ld	(KEYCNT),a

	pop	af
	ei
	ret

KEYDATA:db	$00	; L[͓e
KEYCNT:	db	$00	; I[gs[g̃LZpJE^


;
; L[͊荞݂Q
;
INTKEYIN2:
	push	af
	call	GETSUBCPU
	cp	$fe		; 
	jr	nz,.end

	ld	a,(KANAFLAG)
	cpl
	ld	(KANAFLAG),a
.end:
	pop	af
	ei
	ret

KANAFLAG:
	db	$00	; ȃL[tOi0xff/0x00F/pj

;
; L[f[^ǂݏo
; RETURN
; AFǂݏoL[f[^
; Zflag=1AL[f[^Ȃ
;
KEYREAD:
	di
	push	hl
	ld	hl,KEYDATA
	ld	a,(hl)
	ld	(hl),$00
	pop	hl
	ei
	or	a
	ret

;
; ^C}荞
;
INTTIMER:
	push	af
	push	hl

	ld	a,(KEYCNT)
	inc	a
	and	$3f
	ld	(KEYCNT),a
	jr	nz,.n1
	ld	(KEYDATA),a	; 0x00NA
.n1:
	ld	hl,BLINKCNT
	inc	(hl)
	jr	nz,.end
	set	7,(hl)
	inc	hl
	ld	(hl),$ff
	inc	hl
	ld	a,(hl)
	cpl
	ld	(hl),a

.end:	pop	hl
	pop	af
	ei
	ret

BLINKCNT:
	db	$80		; J[\_ŗpJE^
BLINKFLAG:
	db	$00		; J[\_ŗptO(0x00ȊOŕ\ωj
BLINKDISP:
	db	$00		; J[\\(0x00)/\(0xff)

;
; BIOS[`֔
;
JPMAIN:
	ld	(.sppt+1),sp
	ld	sp,$bc00
	push	hl
	ld	hl,.ret		; ߂
	ex	(sp),hl

		; 0x0000`0xffff̓ǂݏRAM
	ld	a,$dd
	out	($f1),a
	out	($f0),a
	ld	a,$55
	out	($f2),a

	jp	(hl)

.ret:
		; 0xc000`0xffff̓ǂݏORAM
	ld	a,$ed
	out	($f1),a
	ld	a,$dd
	out	($f0),a
	ld	a,$95
	out	($f2),a

.sppt:	ld	sp,$0000
	ret

;
; BIOS̏
;
INIT_BIOS:
	xor	a
	ld	(KANJIFLAG),a
	ld	(CURXY+0),a
	ld	(CURXY+1),a

	ld	hl,STDINBUF
	ld	b,STDINBUFLEN
.lp1:
	ld	(hl),a
	inc	hl
	djnz	.lp1
	ret

;
; ʂɂP\
; AFLN^ԍ
;
PUTLETTER:
	push	af
	push	bc
	push	de
	push	hl
	push	iy

	ld	b,a
	ld	a,(KANJIFLAG)
	or	a
	jr	nz,.byte2

		; PoCg
		;
.byte1:
	ld	a,b
	cp	$20
	jr	c,.ctl
	cp	$80
	jr	c,.asc
	cp	$a0
	jr	c,.kanji
	cp	$e0
	jr	c,.asc


		; 0x80`0x9f/0xe0`0xffiSpj
		;
.kanji:
	ld	(KANJIFLAG),a
	jr	.end

		;
		; 0x00`0x1fiRg[R[hj
.ctl:
	cp	$0a		; LF(CR)
	call	z,PRINTLFCR
	cp	$0c		; CLS
	call	z,PRINTCLS
	cp	$08		; DEL
	call	z,PRINTDEL
	cp	$1d		; 
	call	z,PRINTDEL

	jr	.end

.asc:
		;
		; 0x20`0x7f/0xa0`0xdfippApJij
	ld	b,a
	xor	a

.byte2:
		; QoCg
		;
	ld	h,a
	ld	l,b

	call	CALCKANJIADD	; p^[̃TCYAAhXZo

	push	bc
	call	PATREAD		; p^[ǂݏoAobt@Ɋi[
	pop	bc

	call	CALCVRAM	; VRAMAhXZo

	push	bc
	call	DRAWPAT		; p^[`
	pop	bc

	xor	a
	ld	(KANJIFLAG),a

	ld	a,(CURXY)	; XW
	ld	l,a
	ld	h,0
	ld	de,LINEBUF
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	a,c
	cp	$01
	jr	z,.sb1
	ld	(hl),c
.sb1:
	ld	a,(CURXY)	; XW
	add	a,c
	ld	(CURXY),a	; XW
	cp	STDOUTLEN
	jr	c,.end

	call	PRINTLFCR

.end:
	pop	iy
	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

;
; VRAMAhXvZ
; RETURN
; HL:VRAMAhX
;
CALCVRAM:
	ld	de,(CURXY)

		; hx12x40 = hx32x15 (h=0`15j
	ld	a,d
	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	add	a,a		; x16
	sub	d		; x15
	ld	l,a
	ld	h,0
	add	hl,hl		; x30
	add	hl,hl		; x60
	add	hl,hl		; x120
	add	hl,hl		; x240
	add	hl,hl		; x480
	ld	d,$c0		; VRAM擪
	srl	e
	add	hl,de		; VRAMAhX
	ret

;
; LN^f[^obt@ɓ]
; HLFf[^AhX
; CFTCY
;
PATREAD:
	ld	de,CHRBUF

	ld	a,c		; TCY
	cp	$02
	jr	z,.byte2

.byte1:
	ld	b,6
	ld	a,(CURXY)	; XW
	bit	0,a
	jr	nz,.odd1

.even1:
	ld	a,(hl)
	ld	c,a
	and	$f0
	ld	(de),a		; PoCg
	inc	de
	ld	a,c
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	ld	(de),a		; QoCg
	inc	de
	inc	hl
	djnz	.even1
	ret

.odd1:
	ld	a,(hl)
	ld	c,a
	and	$f0
	rrca
	rrca
	rrca
	rrca
	ld	(de),a		; PoCg
	inc	de
	ld	a,c
	and	$0f
	ld	(de),a		; QoCg
	inc	de
	inc	hl
	djnz	.odd1
	ret


.byte2:
	ld	b,11
	ld	a,(CURXY)	; XW
	bit	0,a
	jr	nz,.odd2

.even2:
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	de
	djnz	.even2
	xor	a
	ld	(de),a
	ret

.odd2:
	push	de
	pop	iy
.lp1:
	ld	a,(hl)
	ld	c,a
	and	$f0
	rrca
	rrca
	rrca
	rrca
	ld	(de),a
	ld	a,c
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	ld	(iy+12),a
	inc	hl
	inc	de
	inc	iy
	djnz	.lp1
	xor	a
	ld	(de),a
	ld	(iy+12),a
	ret

;
; p^[`悷
; HLFVRAMAhX
; C FTCY
;
DRAWPAT:
	ex	de,hl
	ld	hl,CHRBUF
	ld	a,c		; TCY
	cp	$02
	jr	z,.byte2

.byte1:
	ld	a,(CURXY)	; XW
	bit	0,a
	jr	nz,.odd1

.even1:
	ld	c,$0f
	jr	DRAWPAT_SUB

.odd1:
	ld	c,$f0
	jr	DRAWPAT_SUB

.byte2:
	ld	a,(CURXY)	; XW
	bit	0,a
	jr	nz,.odd2

.even2:
	ld	c,$00
	jr	DRAWPAT_SUB

.odd2:
	push	de
	ld	c,$f0
	call	DRAWPAT_SUB
	pop	de
	inc	de
	ld	c,$0f
	jr	DRAWPAT_SUB

;
; 8x12̃p^[`悷
; DEFVRAMAhX
; HLFp^[obt@AhX
; CF`p}XN
;
DRAWPAT_SUB:
	ld	b,12
.lp1:
;	ld	a,(de)		; `悵Ăf[^iv[Oj
;	and	c		; }XNp^[
;	or	(hl)		; p^[
;	ld	(de),a

	set	5,d

	ld	a,(de)		; `悵Ăf[^iv[Pj
	and	c		; }XNp^[
	or	(hl)		; p^[
	ld	(de),a

	inc	hl
	push	hl
	ld	hl,40-$2000
	add	hl,de
	ex	de,hl
	pop	hl

	djnz	.lp1
	ret

;
; sƃXN[
;
PRINTLFCR:
	push	af
	ld	hl,(CURXY)
	inc	h
	ld	a,h
	cp	16
	jr	c,.end

		;
		; XN[

;	ld	hl,$c000 + 40*12	; v[O
;	ld	de,$c000
;	ld	bc,40*12*15
;	ldir
;
;	ld	l,e
;	ld	h,d
;	ld	(hl),$00
;	inc	hl
;	ex	de,hl
;	ld	bc,40*12-1
;	ldir

	ld	hl,$e000 + 40*12	; v[P
	ld	de,$e000
	ld	bc,40*12*15
	ldir

	ld	l,e
	ld	h,d
	ld	(hl),$00
	inc	hl
	ex	de,hl
	ld	bc,40*12-1
	ldir

	ld	h,15
.end:
	ld	l,0		; XW
	ld	(CURXY),hl
	ld	b,STDOUTLEN+2
	ld	hl,LINEBUF
	ld	a,$01
.lp1:
	ld	(hl),a
	inc	hl
	djnz	.lp1
	pop	af
	ret

;
; ʃNA
;
PRINTCLS:
	push	af

	ld	hl,$c000
	ld	(hl),$00
	ld	de,$c001
	ld	bc,$4000-1
	ldir

	ld	hl,$0000
	ld	(CURXY),hl
	pop	af
	ret

;
; P폜
;
PRINTDEL:
	push	af
	push	de
	push	hl

	ld	c,0

	ld	a,(CURXY)	; XW
	or	a
	jr	z,.end

	ld	l,a
	ld	h,0
	ld	de,LINEBUF
	add	hl,de
	dec	hl
	ld	a,(hl)
	cp	$01
	jr	z,.del1

	ld	a,(CURXY)
	dec	a
	jr	z,.end
	ld	b,a
	ld	(CURXY),a
	ld	a,' '
	call	PUTLETTER	; P\
	ld	a,b
	ld	(CURXY),a
	inc	c
.del1:
	ld	a,(CURXY)
	dec	a
	ld	b,a
	ld	(CURXY),a
	ld	a,' '
	call	PUTLETTER	; P\
	ld	a,b
	ld	(CURXY),a
	inc	c
.end:
	pop	hl
	pop	de
	pop	af
	ret


KANJIFLAG:
	db	$00			; QoCgA<> 0x00
CURXY:
	dw	$0000
CHRBUF:
	db	24 dup ($00)		; \f[^̃e|
LINEBUF:
	db	STDOUTLEN+2 dup ($01)	; \PoCg=0x01^QoCg0x02


; SHIFT-JISR[hATCYAAhXZo
; HLFSHIFT-JISiṕALreĝݎgpj
; RETURN
; HLFf[^AhX
; C FTCY
;
CALCKANJIADD:
	ld	a,h
	or	a
	jr	nz,.kj1

		; p
		;
		; 0x00`0x1f
		; 0x80`0x9f
		; 0xe0`0xffȂ
		;
	ld	a,l
	sub	$20
	jr	c,.hspc
	cp	$80-$20
	jr	c,.hd1
	sub	$20
	jr	c,.hspc

.hd1:
	ld	l,a
	ld	h,0
	ld	c,l
	ld	b,h
	add	hl,hl		; x2
	add	hl,bc		; x3
	add	hl,hl		; x6
	ld	bc,$0040	; 4x12i[AhX擪
	add	hl,bc
	ld	c,$01
	ret

.hspc:
	xor	a		; SPACE
	jr	.hd1


.kj1:

		; Sp
		;
		; 0x??00`0x??3f,0x??7e,0x??fd`0x??ffȂ
		; (188)
		;
		; 0x81??`0x83??
		; 0x8440`0x849e
		;
		; 0x889f`0x88fc
		; 0x89??`
		;

	ex	de,hl
	ld	hl,$e0d6	; 
	or	a
	sbc	hl,de
	jr	nz,.nk1
	ld	de,$9873	; "r"{PɕύX

.nk1:
	ld	hl,$e84a	; J
	or	a
	sbc	hl,de
	jr	nz,.nk2
	ld	de,$9874	; "r"{QɕύX

.nk2:
	ex	de,hl
	ld	d,h
	ld	a,h
	sub	$81
	jr	c,.kspc		; 0x8100
	cp	$85-$81
	jr	c,.bk1		; 0x8100-0x84ff
	sub	$04
.bk1:
	ld	b,a
	ld	a,l
	sub	$40
	jr	c,.kspc		; ʂ0x00-0x3f
	cp	$7f-$40
	jr	c,.bk2		; ʂ0x40-0x7e
	jr	z,.kspc		; ʂ0x7f
	dec	a
.bk2:
		;
		; HL <= B x 188 + A
		; (B0`20j
	ld	h,b
	ld	l,a		; HL=B*256+A
	xor	a
	srl	b
	rra
	srl	b
	rra			; BA=B*64
	add	a,h
	add	a,h
	add	a,h		; 3{łő60=%111100 cfオȂ
	add	a,h		; Ōオ̉\L
	ld	c,a		; BC=B*68
	jr	nc,.bk3
	inc	b
	xor	a
.bk3:
	sbc	hl,bc		; HL=(B*256+C)-(B*68)=B*188+C

.kd1:
	ld	c,l
	ld	b,h
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,bc		; x5
	add	hl,hl		; x10
	add	hl,bc		; x11
	ld	bc,$0400	; 8x12i[AhX擪
	add	hl,bc
	ld	c,$02
	ret

.kspc:
	ld	hl,$0000
	jr	.kd1

;
; P\
; CFLN^
;
PUTCHAR:
	ei

	ld	a,c
	call	PUTLETTER	; Po

.lp1:
	call	KEYREAD
	jr	z,.n2		; L[͂Ȃ
	cp	$1b		; ESC
	jr	nz,.lp1

			; ESCAESC܂ő҂
			;

.lp2:
	call	KEYREAD
	jr	z,.lp2		; L[͂Ȃ
	cp	$1b		; ESC
	jr	nz,.lp2

.n2:
	di
	ret


; P
; RETURN
; HLFLN^
;
GETCHAR:
	ei

	ld	a,(STDINBUF)
	or	a
	jp	nz,.dout

		; obt@Ƀf[^Ȃꍇ
		;
	ld	de,STDINBUF	; ͗pobt@
	ld	b,0
	di
	ld	hl,BLINKCNT
	ld	(hl),$80
	inc	hl
	ld	(hl),$00
	inc	hl
	ld	(hl),$ff
	ei

.lp1:
	call	KEYREAD

	di
	push	af
	jr	z,.lp0
	ld	a,$ff		; J[\Iɏ
	ld	(BLINKFLAG),a
	ld	(BLINKDISP),a
.lp0:
	call	BLINKCURSOR
	pop	af
	ei

	jr	z,.lp1

	cp	$20
	jr	nc,.nom

	cp	$0a
	jp	z,.lf
	cp	$0c
	jr	z,.cls
	cp	$08
	jr	z,.bs
	cp	$1d
	jr	nz,.lp1

		; P폜
		;
.bs:
	call	PRINTDEL	; P폜
	inc	c
.bslp:
	dec	c
	jr	z,.lp1
	dec	de
	xor	a
	ld	(de),a
	jr	.bslp

.cls:
	call	PRINTDEL	; P폜
	inc	c
	dec	c
	jr	z,.lp1
	inc	c
.clslp:
	dec	c
	jr	z,.cls
	dec	de
	xor	a
	ld	(de),a
	jr	.clslp

.nom:
	ld	c,a
	ld	a,b
	cp	STDINBUFLEN-4	; obt@TCY
	jp	nc,.lp1		; ̓obt@c菭Ȃ͓͂Ȃ
	ld	a,c
	cp	$80
	jr	c,.asc
	sub	$80
	cp	$a0-$80
	ld	c,$82
	jr	c,.hira
	cp	$e0-$80
	jr	nc,.hira
	ld	c,$83
.hira:
	cp	$de-$80		; _
	jr	z,.dak
	cp	$df-$80		; _
	jr	z,.handak
	ld	hl,HIRATBL
	add	a,l
	ld	l,a
	ld	a,0
	adc	a,h
	ld	h,a
	ld	a,(hl)
	or	a
	jp	z,.lp1		; f[^ȂȂ̂Ŗ߂
	cp	$ff
	jr	nz,.nods
	ld	c,$81
	ld	a,$5b		; [

.nods:
	ld	l,a
	ld	a,c
	call	PUTLETTER	; GR[obN
	ld	(de),a
	inc	de
	inc	b
	ld	a,l
.asc:
	call	PUTLETTER	; GR[obN
	ld	(de),a
	inc	de
	inc	b
	jp	.lp1

.dak:
	ld	c,1
	ld	hl,DAK_HTBL_e - DAK_HTBL
	jp	.dak1
.handak:
	ld	c,2
	ld	hl,HANDAK_HTBL_e - DAK_HTBL
.dak1:
	ld	(.dakln+1),hl
	ld	a,b
	cp	2
	jp	c,.lp1		; OɕȂꍇA߂

	dec	de
	dec	de
	ld	a,(de)
	inc	de
	inc	de
	cp	$82
	ld	hl,DAK_HTBL
	jr	z,.dak2
	cp	$83
	jp	nz,.lp1

	ld	hl,DAK_KTBL
.dak2:
	push	bc
	dec	de
	ld	a,(de)
	inc	de
.dakln:	ld	bc,$0000
	cpir
	pop	bc
	jp	nz,.lp1

	ld	l,c
	call	PRINTDEL	; P폜

	dec	b
	dec	b
	dec	de
	ld	a,(de)
	add	a,l
	ld	l,a
	dec	de
	ld	a,(de)
	ld	c,a
	ld	a,l
	jp	.nods

.lf:
	ld	a,$0a
	call	PUTLETTER	; Po
	ld	(de),a


		; obt@̃f[^o
		;
.dout:
	ld	de,STDINBUF
	ld	a,(de)
	ld	hl,STDINBUF+1
	ld	bc,STDINBUFLEN-1
	ldir

	ld	l,a
	ld	h,0
	xor	a
	ld	(STDINBUF+STDINBUFLEN-1),a

	di
	ret


; ͗pobt@
;
STDINBUF:
	db	STDINBUFLEN dup ($00)


; Ђ炪/J^JiSHIFT-JISϊe[u
HIRATBL:
	db	$00,$00,$00,$00	; 0x80 ; EEEE
	db	$00,$00,$f0,$9f	; 0x84 ; EE
	db	$a1,$a3,$a5,$a7	; 0x88 ; 
	db	$e1,$e3,$e5,$c1	; 0x8c ; 
	db	$9e,$a0,$a2,$a4	; 0x90 ; E
	db	$a6,$a8,$a9,$ab	; 0x94 ; 
	db	$ad,$af,$b1,$b3	; 0x98 ; 
	db	$b5,$b7,$b9,$bb	; 0x9c ; 
	db	$00,$00,$00,$00	; 0xa0 ; EBuv
	db	$00,$00,$92,$40	; 0xa4 ; AE@
	db	$42,$44,$46,$48	; 0xa8 ; BDFH
	db	$83,$85,$87,$62	; 0xac ; b
	db	$ff,$41,$43,$45	; 0xb0 ; [ACEi[F0x815bj
	db	$47,$49,$4a,$4c	; 0xb4 ; GIJL
	db	$4e,$50,$52,$54	; 0xb8 ; NPRT
	db	$56,$58,$5a,$5c	; 0xbc ; VXZ\ (ASł͕"\"NGj
	db	$5e,$60,$63,$65	; 0xc0 ; ^`ce
	db	$67,$69,$6a,$6b	; 0xc4 ; gijk
	db	$6c,$6d,$6e,$71	; 0xc8 ; lmnq
	db	$74,$77,$7a,$7d	; 0xcc ; twz}
	db	$7e,$80,$81,$82	; 0xd0 ; ~
	db	$84,$86,$88,$89	; 0xd4 ; 
	db	$8a,$8b,$8c,$8d	; 0xd8 ; 
	db	$8f,$93,$00,$00	; 0xdc ; JK
	db	$bd,$bf,$c2,$c4	; 0xe0 ; 
	db	$c6,$c8,$c9,$ca	; 0xe4 ; ƂȂɂ
	db	$cb,$cc,$cd,$d0	; 0xe8 ; ˂̂͂
	db	$d3,$d6,$d9,$dc	; 0xec ; ӂւق
	db	$dd,$de,$df,$e0	; 0xf0 ; ݂ނ߂
	db	$e2,$e4,$e6,$e7	; 0xf4 ; 
	db	$e8,$e9,$ea,$eb	; 0xf8 ; 
	db	$ed,$f1,$9e,$9e	; 0xfc ; EE

;
; _/_pe[uiЂ炪ȁj
;
DAK_HTBL:
	db	$cd,$d0,$d3,$d6,$d9	; ͂Ђӂւ
HANDAK_HTBL_e:
	db	$a9,$ab,$ad,$af,$b1	; 
	db	$b3,$b5,$b7,$b9,$bb	; 
	db	$bd,$bf,$c2,$c4,$c6	; Ă
DAK_HTBL_e:

;
; _/_pe[uiJ^Jij
;
DAK_KTBL:
	db	$6e,$71,$74,$77,$7a	; nqtwz
HANDAK_KTBL_e:
	db	$4a,$4c,$4e,$50,$52	; JLNPR
	db	$54,$56,$58,$5a,$5c	; TVXZ\ (ASł͕"\"NGj
	db	$5e,$60,$63,$65,$67	; ^`ceg
DAK_KTBL_e:

;
; J[\_ł
;
BLINKCURSOR:
	ld	a,(BLINKFLAG)
	or	a
	ret	z

	push	hl
	ld	hl,$8140	; Sp
	ld	a,(BLINKDISP)
	or	a
	jr	nz,.n1
	ld	hl,$9875	; x^
	ld	a,(KANAFLAG)
	or	a
	jr	nz,.n1
	ld	hl,$7f20	; x^ipj{󔒁ipj
.n1:
	ld	a,h
	call	PUTLETTER
	ld	a,l
	call	PUTLETTER

	ld	hl,CURXY
	dec	(hl)
	dec	(hl)

	pop	hl
	ret


; obt@̐擪ɂP͂
; CFLN^
;
UNGETCIN:
	ei
	ld	a,c

	ld	hl,STDINBUF + STDINBUFLEN-2
	ld	de,STDINBUF + STDINBUFLEN-1
	ld	bc,STDINBUFLEN-1
	lddr

	ld	(de),a

	di
	ret

;
; RWX^̒lԂ
; RETURN
; HLFRWX^̓e
;
GETRREG:
	ei

	ld	a,r
	ld	l,a
	ld	h,0

	di
	ret

;
; fBXNf[^PoCgǂݏo
;
; DEFAhX
; RETURN
; HLFf[^
;
DATA_READ:
	push	de
	call	READ_BYTE
	pop	de
	ld	b,a

	inc	de
	ld	hl,(DATA_START)
	add	hl,de
	ld	a,l
	xor	b
	ld	l,a
	ld	h,0
	ret

;
; f[^X^[gZbg
; DEFX^[gf[^
;
DATA_READSET:
	ld	(DATA_START),de	
	ld	a,$ff
	ld	(BUFNUM),a
	ret

DATA_START:
	dw	$0000

;
; fBXNf[^PoCgǂݏo
; DEFf[^|C^
; RETURN
; AFǂݏof[^
;
READ_BYTE:
	ld	a,(BUFNUM)
	cp	d
	call	nz,.diskrd
	ld	d,0
	ld	hl,DISKBUF
	add	hl,de
	ld	a,(hl)
	ret

.diskrd:
	push	de
	ld	a,d
	ld	(BUFNUM),a
	and	$0f
	inc	a
	ld	e,a		; ZN^ԍ

	ld	a,d
	and	$f0
	rrca
	rrca
	rrca
	rrca
	add	a,DATATR
	ld	d,a		; gbNԍ

	call	READ_SEC
	pop	de
	ret

BUFNUM:	db	$ff

;
; PZN^ǂݏo
; DFgbNԍ
; EFZN^ԍ
;
READ_SEC:
	ld	hl,DISKBUF
	ld	bc,$0100	; ZN^/gbNԍ
	call	Disk_Load
	ret

;
; PZN^ǂݏo
; DFgbNԍ
; EFZN^ԍ
; RETURN
; HLFʏ펞A0x0000/G[0xFFFFA
;
SECRD_SET:
	call	READ_SEC
	ld	hl,0
	sbc	hl,hl
	ld	a,$ff
	ld	(BUFNUM),a
	ret

;
; PZN^
; DFgbNԍ
; EFZN^ԍ
; RETURN
; HLFʏ펞A0x0000/G[0xFFFFA
;
SECWR_SET:
	ld	hl,DISKBUF
	ld	bc,$0100	; ZN^/gbNԍ
	call	Disk_Save
	ld	hl,0
	sbc	hl,hl
	ret

;
; f[^obt@PoCgǂݏo
; DEFf[^|C^
; RETURN
; HL Fǂݏof[^
;
SECRD_BYTE:
	ld	hl,DISKBUF	; i[擪AhX
	ld	d,0
	add	hl,de
	ld	l,(hl)
	ld	h,0
	ret

;
; f[^obt@ɂPoCg
; DEFf[^|C^
; CFރf[^
;
SECWR_BYTE:
	ld	hl,DISKBUF	; i[擪AhX
	ld	d,0
	add	hl,de
	ld	(hl),c
	ret


	org	$b6ff
	db	$ff

end

